# frozen_string_literal: true

class UploadDocInSneJob < ActiveJob::Base

  queue_as :z_upload_in_sne
  unique :until_executed
  
  def perform(required_document_id)
    if required_document = Hermes::RequiredDocument.find(required_document_id)
      required_document.concerned_unique_numbers_and_housing_request_id.each do |unique_numbers_and_housing_request_id|
        if required_document.exists_in_sne
          required_document.update_file_in_sne(unique_numbers_and_housing_request_id[:unique_number], unique_numbers_and_housing_request_id[:housing_request_id])
        else
          required_document.create_file_in_sne(unique_numbers_and_housing_request_id[:unique_number], unique_numbers_and_housing_request_id[:housing_request_id])
        end
      end
    end
  end
end
