require 'rails_helper'
require 'vcr_config'

# exemple d'utilisation
=begin
a1 = Hermes::Applicant.create( monthly_charges: {},nationality:"1",)
        work_contract_type: "Agents publics",
        has_other_employers: true,
        year_minus_one: Date.current.year,
        amount_year_minus_one: "123",
        birth_date:Date.current,

        family_situation:"Mariée",
        civility:"Monsieur",user:User.first)

hr = Hermes::HousingRequest.create(  is_active: true,main_applicant: a1)
          id_counter: "alpha",
          internal_ref: "alpha",
          sne_creation_date: DateTime.new,
          forcing_duplicate: true,
          electronical_renewal: true,
          seeked_housing_categories: ["alpha"],
          seeking_first_floor: true,
          seeking_elevator: true,
          seeked_max_rent: 451,
          widen_request: true,
          seeked_types: ["alpha", "bravo"],
          seeked_districts: ["30100", "30100"],
          seeked_district_postal_codes: ["30100", "30101"],
          actual_housing_details:{'appartment_staircase': "33","host": 'A',"housing_surface": "200",'appartment_building':"A","housing_typology":"1","address_add_address":"à droite  con !!!!!!!!!!!","APL_monthly_amount":"120","number_of_resident": "2", "monthly_rental_amount": "380",'address_actual_housing_details':{"code":30100}},
          postal_details:{'appartment_number':30,"host": 'A', 'address_postal_details':{'code': "30100"}},
          requester_lastname: "alpha",
          requester_firstname: "alpha",
          is_house_owner: true,
          motivation3: "Démolition")

hrs = Hermes::HousingRequest.where(last_send_has_error: true)
hrs.count
hrs.each_with_index do | hr,i |
  so=Hermes::BoClient::AddRequestTask.new({:'housing_request_id'=> hr.id})
  so.to_xml
  ExecuteSopraTaskJob.perform_now(so.endpoint, so.to_xml, "post", "Hermes::HousingRequest", hr.id.to_s)
  ap i 
end

hrs = Hermes::HousingRequest.where(request_status: "EN ATTENTE DE NUD")
hrs.count
hrs.each_with_index do | hr,i |
  so=Hermes::BoClient::AddRequestTask.new({:'housing_request_id'=> hr.id})
  so.to_xml
  ExecuteSopraTaskJob.perform_now(so.endpoint, so.to_xml, "post", "Hermes::HousingRequest", hr.id.to_s)
  ap i 
end

=end
dir_path = File.dirname(__FILE__)
schema_path = [dir_path, 'InterfaceNuu_v0300.xsd'].join('/')
require [Hermes::Engine.root, %w[lib hermes bo_client tasks]].flatten.join('/').to_s

RSpec.describe Hermes::BoClient::AddRequestTask, type: :helper do
  let!(:xsd) { Nokogiri::XML::Schema(File.read(schema_path)) }
  let!(:user1) { create(:user) }
  let!(:applicant1) {
    create(
        :applicant,
        user: user1,
        monthly_charges: {},
        work_contract_type: "APP",
        has_other_employers: true,
        nationality: "1",
        family_situation:'V',
        year_minus_one: Date.current.year,
        amount_year_minus_one: "123",
        birth_date:Date.current,
        civility:"1",
        workplace_insee_code: "",
        sne_profile_creation_date: Date.current - 20.days,
        foreign_workplace_postal_code: "754114",
        foreign_workplace_locality: "Villedechine",
        foreign_workplace_country: "Chine",
        )
  }

  it 'should load a valid XSD' do
    expect(xsd).to be_present
    expect(xsd.class).to be Nokogiri::XML::Schema
  end

  context 'with simple housing_request' do
    let!(:applicant) {create(:applicant)}

    let!(:housing_request1) do
      create(
          :housing_request,
          is_active: true,
          main_applicant: applicant1,
          id_counter: "alpha",

          internal_ref: "alpha",
          seeked_localisation_list: [
              {
                  "nom": "Fréjus",
                  "code": "83061",
                  "codeDepartement": "83",
                  "codeRegion": "93",
                  "codesPostaux": [
                      "83600",
                      "83370"
                  ],
                  "population": 53168,
                  "_score": 1
              },
              {
                  "nom": "Fréjzus",
                  "code": "84061",
                  "codeDepartement": "81",
                  "codeRegion": "92",
                  "codesPostaux": [
                      "80600",
                      "80370"
                  ],
                  "population": 53168,
                  "_score": 1
              },
          ],
          forcing_duplicate: true,
          electronical_renewal: true,
          seeked_housing_categories: ["J"],
          seeking_first_floor: true,
          seeking_elevator: true,
          seeked_max_rent: 451,

          widen_request: true,
          seeked_types: ["T1", "T2"],
          typology_range: ["T1"],
          housing_type_list:["HLM"],
          actual_housing_details: {
            "postal_code"=>"75004",
            "appartment"=>"12",
            "floor"=>"12",
            "stair"=>"12",
            "building"=>"12",
            "company_adress"=>"douzeee",
            "number"=>"12",
            "way"=>"douzeee",
            "known_place"=>"douzeee",
            "district"=>"Paris",
            "address_insee_code"=>"75104"}, 
                      postal_details: {"appartment_building"=>"12",
            "appartment_staircase"=>"12",
            "appartment_floor"=>"12",
            "appartment_number"=>"12",
            "address_number"=>"12",
            "address_street"=>"douze",
            "address_add_address"=>"douze",
            "address_place"=>"douze",
            "postal_code"=>"75002",
            "district"=>"Paris",
            "address_insee_code"=>"75102"},
                      owned_housing_details: {"type"=>nil,
            "postal_code"=>nil,
            "district"=>nil
          },
          requester_lastname: "alpha",
          requester_firstname: "alpha",
          is_house_owner: true,
          motivation1: "02",
          motivation3: "01",

      )
    end
    let!(:nud3) do
      create(
          :nud,
          housing_request: housing_request1,
          department: '14',
          creation_date: '2017-23-14T14:53:22',
          unique_number:"54739274"
      )
    end

    describe 'using to_xml' do
      let!(:add_request_task1) do
        build(
            :add_request_task,
            options: {nud_id: housing_request1.nud_ids[0] ,housing_request_id: housing_request1.reload.id }
        )
      end
      it 'verify xml_must_be_sended'  do
        housing_request1.last_xml_flux_30 = add_request_task1.to_xml
        housing_request1.is_sne_update_available =  true
        housing_request1.save
        expect(housing_request1.xml_must_be_sended(Hermes::BoClient::AddRequestTask.new(housing_request_id: housing_request1.id, nud_id: housing_request1.nud_ids[0]).to_xml)).to eq(false)
      end
      it 'verify xml_must_be_sended true'  do
        housing_request1.last_xml_flux_30 = add_request_task1.to_xml
        housing_request1.save
        housing_request1.motivation1 =  "03"
        housing_request1.save
        expect(housing_request1.xml_must_be_sended(Hermes::BoClient::AddRequestTask.new(housing_request_id: housing_request1.id, nud_id: housing_request1.nud_ids[0]).to_xml)).to eq(true)
      end
      it 'should return a valid xml' do
        xsd.validate(Nokogiri::XML(add_request_task1.to_xml))
        add_request_task1.validate_xml
        housing_request1.reload
        puts add_request_task1.to_xml
        expect(housing_request1.reload.last_xml_validation_report).to eq("[]")
        so=Hermes::BoClient::AddRequestTask.new({:'housing_request_id'=> housing_request1.id})
        so.execute
        VCR.use_cassette("flux30", :match_requests_on => [:method, :uri, :path]) do
          drain_all_jobs
        end

        expect(housing_request1.reload.last_send_has_error).to eq(true)
        
        expect(xsd.validate(Nokogiri::XML(add_request_task1.to_xml)).length).to eq(0)
      end
    end
  end
end